//=============================================================================
//
//  CLASS SuperToroid - IMPLEMENTATION
//
//=============================================================================
#define RAYTRACER_SUPERTOROID_CPP

//== INCLUDES =================================================================
#include "SuperToroid.h"

//== IMPLEMENTATION ==========================================================
//-----------------------------------------------------------------------------
bool SuperToroid::intersect(
    const Ray       &clRay, 
    double        t0,     
    double        t1,     
    TracingContext  &tContext )  const
{
    /*
		Implementieren Sie:
		
		Strahl-SuperToroid Schnitt
		Die relevanten (bei Schnitt zu setzenden) Felder im TracingContext sind:

		t          - Strahlparameter des Schnittpunkts
		v3Normal   - Normale im Schnittpunkt
		v3HitPoint - Koordinate des Schnittpunktes
		pclShader  - Verweis auf das Material des SuperToroid
	*/
	return false;
}


//Render GL
void SuperToroid::renderGL() const
{
    //Show AABB instead of object
    glPushMatrix();
    glTranslatef( m_v3Position[0], m_v3Position[1], m_v3Position[2] );
	if( m_selected )
    {
        GLfloat mat_ambient[] = { 1, 1, 1 };
        glMaterialfv( GL_FRONT, GL_AMBIENT, mat_ambient );
    }
    else
        m_shader->shadeGL();
	
	getAABB().renderGL();
    glPopMatrix();
}

//translate object
void SuperToroid::translate(
    float   x,  
    float   y,  
    float   z ) 
{
    m_v3Position[0] = x;
    m_v3Position[1] = y;
    m_v3Position[2] = z;
}

//rotate object
void SuperToroid::rotate(
    float   /*rotx*/,   
    float   /*roty*/,   
    float   /*rotz*/ )  
{

    //Not Implemented yet
}