/** OpenGL-Window
*
* @author
*   Gabriel Zachmann, Sep 2006
*
* @bug
*   I'm sure there is still some bugs left ....
**/
#ifndef GLWIDGET_H
#define GLWIDGET_H
#include <QImage>
#include <QGLWidget>
#include "Raytracer.h"
#include "SurfaceList.h"
#include "PhongShader.h"
#include "Types.h"
class GLWidget : public QGLWidget
{
    Q_OBJECT


public:
    GLWidget( QWidget *father = 0 );
    ~       GLWidget();
    QSize   minimumSizeHint() const;
    QSize   sizeHint() const;
public slots : 
	void	setXRotation ( int angle );
    void    setYRotation( int angle );
    void    setZRotation( int angle );
    void    setXTranslation( int trans );
    void    setYTranslation( int trans );
    void    setZTranslation( int trans );
    void    selectNextObject();
    void    setScene( Raytracer * raytracer,
                      SurfaceList * scene );
    void    renderRays( RayArray * glRays );
    void    reset();
    void    setRayMode( int mode );
	void	startRaytracing( QImage *textureImage );
signals:
    void    xTranslationChanged( int value );
    void    yTranslationChanged( int value );
    void    zTranslationChanged( int value );
    void    xRotationChanged( int angle );
    void    yRotationChanged( int angle );
    void    zRotationChanged( int angle );


protected:
    virtual void    initializeGL();
    virtual void    paintGL();
    virtual void    resizeGL( int width, int height );
    virtual void    keyPressEvent( QKeyEvent *event );


private:
    void                    drawRays();
    int                     m_xRot, m_yRot, m_zRot;
    float                   m_xTrans, m_yTrans, m_zTrans;
    float                   maxTranslation;
    VectorType3  m_selectedNodeOrgTranslation;
    Surface *m_selectedSurface;
    Raytracer *m_raytracer;
    SurfaceList *m_scene;
    RayArray *m_glRays;
	QImage   *m_textureImage;
    bool	  m_showRays;
	QImage    m_imag;//don`t ask why we need this

};
#endif
